#include <owl\framewin.h>
#include <owl\applicat.h>
#include <stdlib.h>
#include <time.h>

//  .
class TCatchApp : public TApplication
{
  public:
   TCatchApp() : TApplication() {}
   void InitMainWindow();
};

//   .
class TCatchWindow : public TFrameWindow
{
  protected:
   int count,             //    .
       timer,             //  .
       score,             //  .
       game_over;         //   .
   char score_string[20]; //  .
  public:
   TCatchWindow(TWindow *parent, const char far *title);
   ~TCatchWindow();
  protected:
   void SetupWindow();
   BOOL CanClose();
   void EvLButtonDown(UINT, TPoint&);
   void EvRButtonDown(UINT, TPoint&);
   void EvTimer(UINT);

   DECLARE_RESPONSE_TABLE(TCatchWindow);
};

DEFINE_RESPONSE_TABLE1(TCatchWindow,TFrameWindow)
  EV_WM_LBUTTONDOWN,
  EV_WM_RBUTTONDOWN,
  EV_WM_TIMER,
END_RESPONSE_TABLE;

//   TCatchWindow.
// TCatchWindow::TCatchWindow()
//    .
TCatchWindow::TCatchWindow(TWindow *parent, const char far *title) :
	 TFrameWindow (parent, title)
{
  //     .
  Attr.Style &= ~(WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_THICKFRAME);
  //       .
  Attr.X = 100;
  Attr.Y = 100;
  Attr.W = 300;
  Attr.H = 100;
}

// TCatchWindow::~TCatchWindow()
//   -   ,
//     .
//     
//   .
TCatchWindow::~TCatchWindow()
{
  //   .
  KillTimer(timer);
}

// TCatchWindow::SetupWindow()
//     SetupWindow()
//  TFrameWindow    
//     .
// SetupWindow() -    
//   ,   
// .
void TCatchWindow::SetupWindow ()
{
  // !    .
  TFrameWindow::SetupWindow();
  //       ,
  randomize();
  game_over = TRUE;
  //   Windows.
  timer = SetTimer(1, 500, 0);
  if (timer == 0)
	 MessageBox("  !", "", MB_OK);
}

//TCatchWindow::EvRButtonDown()
//       WM_RBUTTONDOWN
//   .
void  TCatchWindow::EvRButtonDown(UINT, TPoint&)
{
  //  ,        .
  if (game_over)
  {
	 //   game_over   .
	 game_over  =  FALSE;
	 score = count = 0;
	 //   .
	 SetWindowText("  !");
  }
}

// TCatchWindow::EvLButtonDown()
//     WM_LBOTTONDOWN,
// ,     
//   .
void TCatchWindow::EvLButtonDown(UINT, TPoint&)
{
  //      , 
  //    .
  if (!game_over)
  {
   //      .
   ++score;
   MessageBeep (0);
  }
}

// TCatchWindow::EvTimer()
//       WM_TIMER
//        
//   ,  . 
//    ,  
//  game_over   TRUE  , 
//    30 .
void TCatchWindow::EvTimer(UINT)
{
  //  ,     .
  if (!game_over)
  {
   // ,    
   //    .
   SetActiveWindow();
   //     .
   int maxx = GetSystemMetrics(SM_CXSCREEN);
   int maxy = GetSystemMetrics(SM_CXSCREEN);
   //     .
   int xpos = random(maxx-300);
   int ypos = random(maxy-100);
   //     .
   MoveWindow(xpos, ypos, 300, 100, TRUE);
   //  ,    30 .
   if (++count == 30)
   {
    //   game_over  
    //     .
    game_over = TRUE;
    wsprintf(score_string, " : %d", score);
    MessageBox(score_string, " ", MB_OK);
    //          .
    MoveWindow(100, 100, 300, 100, TRUE);
    SetWindowText("      ");
   }
  }
}

// TCatchWindow::CanClose()
// ,   CanClose()
//  TWindow   
// ,     .
BOOL TCatchWindow::CanClose()
{
  //  ,    ?
  int result = MessageBox(" ?", "",
		MB_YESNO | MB_ICONQUESTION);
  //  CanClose(}  TRUE,  .
  if (result == IDYES) return TRUE;
  else return FALSE;
}

//   TCatchApp.
// TCatchApp:: InitMainWindow()
//      .
void TCatchApp::InitMainWindow()
{
  TFrameWindow *wndw = new TCatchWindow(0, 
            " -     ");
  SetMainWindow(wndw);
}

int OwlMain (int, char*[])
{
  return TCatchApp().Run();
}

